/**
 * Mainloop hookup to Mozilla
 * @see Comment in .cpp file.
 */

#ifndef __xmmsclient_moz_h__
#define __xmmsclient_moz_h__

//extern "C" {
#include "xmmsclient/xmmsclient.h"
//}
#include <xmmsclient/xmmsclient++/mainloop.h>
#include "prio.h"
#include "nsISupports.h"
#include "nsIRunnable.h"
#include "nsIThread.h"
#include "nsCOMPtr.h"

class xmmsMainloopMoz : public nsIRunnable, public Xmms::MainloopInterface
{
    NS_DECL_ISUPPORTS
    NS_DECL_NSIRUNNABLE

    xmmsMainloopMoz(xmmsc_connection_t *c);
    void Init();
    virtual void Close();

    // Xmms::MainloopInterface
    virtual void run();

    // nsIRunnable
    //virtual void Run(); //from DECL above

public:
    PRUint16 mPollFlags;
protected:
    xmmsc_connection_t* mXMMSConn;
    PRFileDesc* mPRFD;
    PRUint16 mPollTimeout;
    nsCOMPtr<nsIThread> mThread;
};

#endif
